close all;clear all;clc
% Dummy case, only one measurement set available

%% Define the matrix
Juu = [244 222;222 202];
Jud = [198 180];

Gy = [ 11 10 1 0 ; 10 9 0 1]';
Gd = [10 9 0 0]';

Wd =1;
Wn = diag([0.01 0.01 0.01 0.01]);
F = [-1 -1 9 -9 ]';
Juu12=Juu^(1/2);
nu=2;
nd=1;
ny=4;

Y = [F*Wd Wn];  
%RandomCase
%% Building the restructured matrices
Ydel=Y;

for i=1:nu-1
    Ydel=blkdiag(Ydel,Y);
end
Fdel=Ydel*Ydel'

Gydel=[];
for i=1:nu
    Gydel=blkdiag(Gydel,Gy);
end
Gydel';

jdel=[];
for i=1:nu
    jdel=[jdel ; Juu12(:,i)];
end


%% Find the optimal number of measurements
M=120; %Big-M
% price for measurements
mprices=0.05*ones(1,ny);  
%Define empty results matrices
cost = zeros(length(nu:ny),1);
loss = zeros(length(nu:ny),1);
Hres=zeros(nu,ny,length(nu:ny));
Meas=zeros(1,ny,length(nu:ny));
% measurements required
for nm=nu:ny % Run through all possible number of measurements

    Q=blkdiag(Fdel,zeros(ny,ny),0);

    A= [Gydel'            zeros(nu*nu,ny)             zeros(nu*nu,1)  ;
        zeros(1,nu*ny)  ones(1,ny)                  -1              ;
        -eye(nu*ny)     -M*repmat(eye(ny),nu,1)     zeros(nu*ny,1)  ;
        eye(nu*ny)      -M*repmat(eye(ny),nu,1)      zeros(nu*ny,1)  ;
        zeros(1,nu*ny)  zeros(1,ny)                  1    ;
        ];

    c = [zeros(1,nu*ny) mprices                0               ];

    lb=[-inf(nu*ny,1);  zeros(ny,1)   ;0  ];
    ub=[inf(nu*ny,1);   ones(ny,1)    ;ny ];

    b= [jdel; 
        0
        zeros(nu*ny,1);
        zeros(nu*ny,1)
        nm
        ];

    
        clear model;
        names = {'y1u1', 'y2u1', 'y3u1','y4u1','y1u2','y2u2','y3u2'...
                 'y4u2','sigma1','sigma2','sigma3','sigma4','nm'};
        model.varnames = names;
        model.Q = sparse(Q);
        model.A = sparse(A);
        model.obj = c;
        model.rhs = b;
        model.lb = lb;
        model.ub = ub;
        model.sense = [repmat('=',nu*nu+1,1);repmat('<',2*nu*ny,1);'='];
        model.modelsense='min'
        model.vtype = [repmat('C',nu*ny,1);repmat('B',ny,1);'I']
        gurobi_write(model, 'MeasSelectPrice0.lp');

        %params.ResultFile = 'test.mps'
        params.Presolve = -1;
        params.FeasibilityTol=1e-9;
        params.OptimalityTol=1e-9;
        %params.FeasibilityTol=1e-4
        results = gurobi(model, params) 
        %results = gurobi(model)
        % for v=1:length(names)
        %     fprintf('%s %e\n', names{v}, results.x(v));
        % end
        fprintf('Obj: %e\n', results.objval);
        % Fill results matrices
        % Selected measurements
        Meas(:,:,nm-nu+1) = results.x(2*ny+1:3*ny)';
        % Selection matrix
        Hres(:,:,nm-nu+1) = [results.x(1:ny)';  results.x(ny+1:2*ny)']; 
        H = (Hres(:,:,nm-nu+1));
        % Total cost
        cost(nm-nu+1)= (results.x'*Q*results.x)/2+model.obj*results.x;
        % Calculate loss with expression from Exact Local Method
        loss(nm-nu+1)= 0.5*norm(Juu12/(H*Gy)*H*Y,'fro')^2;
    
end