close all;clear all;clc
% This is the dummy case for two measurement sets, without constraints
% Cost function: 
% J = (z1 - z2)^2 + (z1- d)^2
Juu = [244 222;222 202];
Jud = [198 180];

Gy = [ 11 10 1 0 ; 10 9 0 1]';
Gd = [10 9 0 0]';

Wd =1;
Wn1 = diag([0.1 0.1 0.1 0.1]);
Wn2 = diag([0.01 0.01 0.01 0.01]);
F = [-1 -1 9 -9 ]';
Juu12=Juu^(1/2);
nu=2;
nd=1;
ny=4;

Y1 = [F*Wd Wn1];  
Y2 = [F*Wd Wn2];
Y = [Y1;Y2];
% Building the restructured matrices
Ydel1=Y1;
Ydel2=Y2;
for i=1:nu-1
    Ydel1=blkdiag(Ydel1,Y1);
    Ydel2=blkdiag(Ydel2,Y2);
    size(Ydel1);
    size(Ydel2);
end
Fdel1=Ydel1*Ydel1';
Fdel2=Ydel2*Ydel2';
Fdel = blkdiag(Fdel1,Fdel2);


%%
Gydel=[];
for i=1:nu
    Gydel=blkdiag(Gydel,Gy);
end
Gydel = [Gydel;Gydel];
Gy1 = [Gy;Gy];
%%
jdel=[];
for i=1:nu
    jdel=[jdel ; Juu12(:,i)];
end
%% Solve for a measurements combination with all measurements
% Create gurobi model
M=100; % Big-M

mprices=[0.02*ones(1,ny) 0.2*ones(1,ny)]; % Prices of measurements

%Define empty result vectors
cost = zeros(length(nu:ny),1);
loss = zeros(length(nu:ny),1);
Hres=zeros(nu,2*ny,length(nu:ny));
Meas=zeros(1,2*ny,length(nu:ny));
Hadj = zeros(nu,2*ny,length(nu:ny));
% If statement so that one only chooses the correct set for corresponding
% to the measurement selection
subM = zeros(ny*nu*2,ny*2); 
for i=1:ny
        subM(i,i+ny) = 1; % u1w1 <-> w2
        subM(i+ny,i+ny)=1; % u2w1 <-> w2
        subM(i+2*ny,i) = 1; % u1w2 <-> w1
        subM(i+3*ny,i) = 1; % u2w2 <-> w1
end

for nm = nu:ny
        %       H  sigma_1      sigma_2      nm
    Q=blkdiag(Fdel,zeros(ny,ny),zeros(ny,ny),0); 
        %H                  sigma_1             sigma_2  %nm               
    A= [Gydel'            zeros(nu*nu,ny)    zeros(nu*nu,ny)         zeros(nu*nu,1)  ;
        zeros(1,nu*ny*2)  ones(1,ny)           ones(1,ny)       -1              ;
         -eye(nu*ny*2)     -M*([repmat(eye(ny),nu,1);zeros(2*ny,ny)]) -M*([zeros(2*ny,ny);repmat(eye(ny),nu,1)]) zeros(nu*ny*2,1);
        eye(nu*ny*2)     -M*([repmat(eye(ny),nu,1);zeros(2*ny,ny)]) -M*([zeros(2*ny,ny);repmat(eye(ny),nu,1)]) zeros(nu*ny*2,1);
        zeros(1,nu*ny*2)  zeros(1,ny)   zeros(1,ny)               1    ;
        eye(nu*ny*2)      M*subM          zeros(ny*nu*2,1);
       -eye(nu*ny*2)      M*subM          zeros(ny*nu*2,1);
        ];

    c = [zeros(1,nu*ny*2) mprices                0               ];
    lb=[-inf(nu*ny*2,1);  zeros(ny,1); zeros(ny,1)  ;0  ];
    ub=[inf(nu*ny*2,1);   ones(ny,1) ; ones(ny,1)  ;ny ];
    b= [jdel; 
        0
        zeros(2*nu*ny,1);
        zeros(2*nu*ny,1)
        nm
        M*ones(2*nu*ny,1)
        M*ones(2*nu*ny,1)
        ];

   
        clear model;
        model.Q = sparse(Q);
        model.A = sparse(A);
        model.obj = c;
        model.rhs = b;
        model.lb = lb;
        model.ub = ub;
        model.sense = [repmat('=',nu*nu+1,1);repmat('<',2*nu*ny,1);...
                       repmat('<',2*nu*ny,1);'=';repmat('<',2*nu*ny,1)...
                       ;repmat('<',2*nu*ny,1)]
        model.modelsense='min'
        model.vtype = [repmat('C',2*nu*ny,1);repmat('B',2*ny,1);'I']
        gurobi_write(model, 'DummyTwoSets.lp');

        params.Presolve = -1;
        params.FeasibilityTol=1e-9;
        params.OptimalityTol=1e-9;
        results = gurobi(model, params) 
        % Selected measurements
        Meas(:,:,nm-nu+1) = [results.x(17:20)' results.x(21:24)']; 
        Measdiag = diag(Meas(:,:,nm-nu+1));
        % prices of measurements
        price(nm-nu+1) = c*results.x;
        % Selection matrix
        Hres(:,:,nm-nu+1) = [results.x(1:4)'  results.x(9:12)'; ...
                             results.x(5:8)' results.x(13:16)'];
        Hadj(:,:,nm-nu+1) = Hres(:,:,nm-nu+1)*Measdiag;
        H = (Hres(:,:,nm-nu+1));
        %Total cost 
        cost(nm-nu+1)= (results.x'*Q*results.x)/2+model.obj*results.x;
        % Unconstrained loss
        loss(nm-nu+1)= 0.5*norm(Juu12/(H*Gy1)*H*Y,'fro')^2;
        
end