function [y]=InitialGuess(x,p,p2,p3)
%InitialGuess(x,p,p2,p3) Finds the values of the state
%vector that are consistent with the 5 first elements
FS_g=x(1);FS_DW=x(2);rin_DW=x(3);FS=x(4);rin=x(5);
qin=p(1);Vo_in=p(2);

%Gravity
[Vo_t,Vo_b]=gavity_sep2(FS_g,qin,Vo_in);
qb=(1-FS_g)*qin;
qt=qin-qb;

%DeWaterer
qi_DW=FS_DW*qt; qo_DW=(1-FS_DW)*qt;
[Vo_LPO_DW,Vo_HPO_DW]=DeWaterer(qt,Vo_t,FS_DW,rin_DW,p3);

%DeOiler
q3=qb+qo_DW;
Vo_3=(Vo_b*qb+Vo_HPO_DW*qo_DW)/q3;
[Vo_LPO_DO,Vo_HPO_DO]=DeOiler(q3,Vo_3,FS,rin,p2);
qi=FS*q3; qo=q3-qi;
%Oil Product
qoil=qi_DW+qi;
Vo_oil=(Vo_LPO_DW*qi_DW+Vo_LPO_DO*qi)/qoil;

%Output
x2=[qt;Vo_t;qb;Vo_b;qi_DW;Vo_LPO_DW;qo_DW;Vo_HPO_DW;...
    q3;Vo_3; qi;Vo_LPO_DO; qo; Vo_HPO_DO; qoil; Vo_oil]; % age; Added ; between q3 and Vo_3, otherwise: error
y=[x;x2];

end