function [t,y]=RK2(ODEfile,tspan,yi,h,varargin)
%2nd-order Runge-Kutta
t=tspan(1):h:tspan(2);
if t(end)~=tspan(2)
    t(end+1)=tspan(2);
end
d=diff(t);
yi=(yi(:).')';

y(:,1)=yi;
for i=1:length(t)-1
    k1=d(i)*feval(ODEfile,t(i),y(:,i),varargin{:});
    k2=d(i)*feval(ODEfile,t(i+1),y(:,i)+k1,varargin{:});
    y(:,i+1)=y(:,i)+(k1+k2)/2;
end
y=y';
t=t';
end