function [c,ceq]=constraints2(x,p,p2,p3,element,Vo_in)
FS_g=x(1);FS_DW=x(2);rin_DW=x(3);FS=x(4);rin=x(5);
qin=p(1);Vo_in=p(2);
Lsw=p2(1);Ro=p2(2);Ri=p2(3);
Lsw_DW=p3(1);Ro_DW=p3(2);Ri_DW=p3(3);

%Gravity
[Vo_t,Vo_b]=gavity_sep2(FS_g,qin,Vo_in);
qb=(1-FS_g)*qin;
qt=qin-qb;
%DeWaterer
qi_DW=FS_DW*qt; %Light phase out flow
qo_DW=qt-qi_DW;    %Heavy phase out flow
ta_DW=pi*Ri_DW^2*Lsw_DW/qi_DW; % eq:3.20

in_DW=[qt,Ro_DW,Ri_DW,Vo_t,ta_DW,rin_DW,FS_DW];
h_DW=ta_DW/10;
[T,X_DW]=RK2(@swirl_sep2_o,[0 ta_DW],rin_DW,h_DW,in_DW,element);
%options = odeset;
%[T,X_DW]= ode45(@swirl_sep2_o,[0 ta_DW],rin_DW,options,in_DW,element);

[Vo_LPO_DW,Vo_HPO_DW]=DeWaterer(qt,Vo_t,FS_DW,rin_DW,p3);

rout_DW=X_DW(end,1);

%DeOiler
q3=qb+qo_DW;
Vo_3=(Vo_b*qb+Vo_HPO_DW*qo_DW)/q3;
qi=FS*q3; %Light phase out flow
qo=q3-qi;    %Heavy phase out flow
ta=pi*(Ro^2-Ri^2)*Lsw/qo;

in=[q3,Ro,Ri,Vo_3,ta,rin,FS];
h=ta/10;
[T,X]=RK2(@swirl_sep2,[0 ta],rin,h,in,element);
%options = odeset;
%[T,X]=ode45(@swirl_sep2,[0 ta],rin,options,in,element);
rout=X(end,1);

[Vo_LPO_DO,Vo_HPO_DO]=DeOiler(q3,Vo_3,FS,rin,p2);

%Oil Product
qoil=qi_DW+qi;
Vo_oil=(Vo_LPO_DW*qi_DW+Vo_LPO_DO*qi)/qoil;

%constraints

%In case of fixed flow splits:
FSzero=[FS_g-0.33;FS_DW-0.91;FS-0.15]; 

ExplEq=[qt;Vo_t;qb;Vo_b;qi_DW;Vo_LPO_DW;...
    qo_DW;Vo_HPO_DW;q3;Vo_3;...
    qi;Vo_LPO_DO; qo; Vo_HPO_DO; qoil; Vo_oil]-x(6:21);
ceq=[(Ri_DW-rout_DW)/Ri_DW;(rout-Ri)/Ri;ExplEq];
c=[0.7-Vo_t;Vo_3-0.6;x(19)-0.01;0.0001-x(19)];%

%c=[0.7-Vo_t;Vo_3-0.6];%
end