function [Vo_t,Vo_b]=gavity_sep2(FS,qin,Vo_in)
Lsep=7;
R=1.7;
Hw=0.75*2*R;
g=-9.81;

qt=FS*qin;
qb=qin-qt;

rhoo=881;rhow=1064;%kg/m^3
% Viscosity (eq:2.7) 
% mum=(0.47*Vo_in^3-0.4*Vo_in^2+0.11*Vo_in+0.001); %Pa*s
mum=(0.6*Vo_in^3-0.506*Vo_in^2+0.137*Vo_in+0.001); %Pa*s
% Droplet size
rd=60*10^-6; %m^3

%Cross section area of weir (eq:3.27)
AHw=R^2/2*((2*acos((R-Hw)/R))-sin(2*acos((R-Hw)/R)));
% Horinzontal velocity of bottom plug flow (eq:3.26)
vh=qb/AHw;
%Vertical velocity of droplet (eq:3.28)
vv=2*g*(rhoo-rhow)*rd^2/(9*mum);
%Droplet Vertical distance travel (eq:3.29)
h=Lsep*vv/vh;
% If the "slowest" droplet of oil travel h>Hw -> No oil in waterphase
d=max(Hw-h,0); %if h>Hw -> Vo_b=0
% if Hw>h there will be oil in bottom:
%Cross section area of bottom section
%that still contains emulsion (Fig:3.11b, eq:3.30)
Ad=R^2/2*((2*acos((R-d)/R))-sin(2*acos((R-d)/R)));

Vw_b=((AHw-Ad)/AHw+Ad/AHw*(1-Vo_in));
Vo_b=1-Vw_b;

Vo_t=(Vo_in-Vo_b*(1-FS))/FS;
if Vo_t>1
    Vo_t=1;
    Vo_b=(Vo_in-Vo_t*FS)/(1-FS);
end

end    
