function [Vo_LPO,Vo_HPO,Edil,Edis,qen]=swirl_func3(Vo_in,qin,FS,element)
Lsw=1.7;
Ro=0.05;
Ri=0.025;

qi=FS*qin; %Light phase out flow
qo=qin-qi;    %Heavy phase out flow
ta=pi*(Ro^2-Ri^2)*Lsw/qo; % (3.9)

% Check for total separation
rin=0.999*Ro;
x0=[rin];
M=zeros(length(x0));
M(1,1)=1;
options = odeset;
in=[qin,Ro,Ri,Vo_in,ta,rin,FS];
h=ta/10;
[T,X]=RK2(@swirl_sep2,[0 ta],x0,h,in,element);% checks for perfect separation
%[T,X]=ode23(@swirl_sep2,[0 ta],x0,options,in,element);

%Finding r(t0) that gives r(ta)=Ri
if X(end,1)>Ri && X(end,1)<Ro % If we don't have perfect separation
    TotSep=0; %Not total separation
    rin_0=0.99*Ro;%Ri+0.5*(Ro-Ri);%[0.038,0.039];%
    rho=1;
    tol=10^-10*Ri;
    [T,X]=shooting(@swirl_sep2,[0,ta],h,Ri,rin_0,rho,tol,in,element);
    rin=X(1,1);
else %If we have perfext separation
    TotSep=1;
    rin=Ro;
end
p2=[Lsw;Ro;Ri];
[Vo_LPO,Vo_HPO,qen]=DeOiler(qin,Vo_in,FS,rin,p2);

Edil=Vo_LPO*qi/(Vo_in*qin);
Edis=1-((1-Vo_LPO)*qi+Vo_HPO*qo)/qin;

