function [Vw_LPO,Vw_HPO,Edil,Edis,qen]=...
    swirl_func3_o(Vo_in,qin,FS,element)
Lsw=1.7;
Ro=0.05;
Ri=0.043;

qi=FS*qin;      %Light phase out flow
qo=qin-qi;      %Heavy phase out flow
ta=pi*Ri^2*Lsw/qi;

%Finding rin=r(t0) that gives r(ta)=Ri
h=ta/10;
rin_0=0.8*Ri;
in=[qin,Ro,Ri,Vo_in,ta,rin_0,FS];
rho=1;
tol=10^-10*Ri;
[T,X]=shooting(@swirl_sep2_o,[0,ta],h,Ri,rin_0,rho,tol,in,element);

rin=X(1,1);
    

[Vo_LPO,Vo_HPO,qen]=DeWaterer(qin,Vo_in,FS,rin,[Lsw;Ro;Ri]);
Vw_LPO=1-Vo_LPO; Vw_HPO=1-Vo_HPO;

%Edil=Vw_HPO*qo/((1-Vo_in)*qin);
Edil=Vo_LPO*qi/((Vo_in)*qin);
Edis=1-((1-Vo_LPO)*qi+Vo_HPO*qo)/qin;
