function [vr]=swirl_sep2_o(t,x,in,element)
% Dewaterer
qin=in(1);
Ro=in(2);
Ri=in(3);
Vo_in=in(4);
ta=in(5);
rin=in(6);
FS=in(7);

Vw_in=(1-Vo_in);

rhoo=881; %kg/m^3
rhow=1064;

r=x(1);

Rc=0.25*Ro;
va=qin/(pi*Ro^2);
if element=='w' %weak
    k=3.5;
elseif element=='s' %strong
    k=5;
elseif element=='l' %large
    k=7;
end
vt0=k*va; %eq:3.5
%Experimental correlation between rd and vt
 %if vt0>4.45%28
    % rd=(-8*vt0+160)/2*10^-6;
    
 %else
   % rd=(-107*vt0+600)/2*10^-6;

 %end
rd= (-107*vt0+600)/2*10^-6+0.5*(1+tanh(10000*(vt0-4.45)))...
    *(((-8*vt0+160)/2*10^-6)-(-107*vt0+600)/2*10^-6);
%rd = 6e-6*vt0^2-0.0001*vt0+0.0007;
%Volume fraction of water on the inside
%of the droplet
Vw=Vw_in*(((1-FS)*Ri^2+FS*(Ri^2-rin^2))...
    /((1-FS)*Ri^2+FS*(Ri^2-r^2)));

%Emprical viscosity 
mum=(0.203*Vw^3+0.237*Vw^2-0.014*Vw+0.0088);

%Smooth centrifugal acceleration
f2=(vt0*exp(-0.04*va*t/(2*Ro)))^2/r; 
f1=(vt0*exp(-0.04*va*t/(2*Ro))/Rc)^2*r;
f=f2-f1; beta=30;
ac=f2-0.5*((f^2+beta^2)^.5+f); % eq:3.18
%vt=sqrt(ac*r);

%Radial velocity of droplet
vr=2/9*(rhow-rhoo)*rd^2/mum*ac; % vr(r,z)eq:3.7
end

