% Script for selfoptimizing control
% Calculates measurements through exact local method
clear all
clc
qin  = 23/3600; % Define a nominal point, inflow 
Vo_in = 0.6;    % Define a nominal point, oil fraction
% Nominal point
%[xnom, cost2] = optimizer(Vo_in,qin);
load('xq23vo06.mat');% Using results from simulations as start points
%lambda = load('lambda1.mat');% Using lambda from simulation 
xnom = x1;
lambda = 0.8817;
nu = 3; ny =16; nd = 2; nc=1;% Number of inputs, measurements, disturbances
yc = 14; % Which y is linked to constrained u3?
nyc = ny-nc; %Total available measurements
nuc = nu-nc; %Total available inputs
%% Add 1% Disturbance to calculate F
di =1.01;
d1 = qin*di;
d2 = Vo_in*di;
deltad1 = d1-qin;
deltad2 = d2-Vo_in;
for i=1:2
    if i == 1
        [xd1, costd1] = optimizer(Vo_in,d1,xnom);
    else 
        [xd2, costd2]= optimizer(d2,qin,xnom);
    end
end
xd = squeeze([xd1 xd2])';
d = [deltad1 deltad2];
%% Calculates sensitivity matrix
F = zeros(ny,nd);
for j = 6:length(xnom)
    for i = 1:length(d)
        F(j-5,i) = (xd(j,i)-xnom(j))/d(i);
    end
end
F(yc,:) = [];
%% Calculate Juu (Hessian)

costu = zeros(nu,nu);
%xud = zeros(nu,nu,nu);
udiff = [0.999 1 1.001];
unom = [xnom(1) xnom(2) xnom(4)];
x0 = squeeze(xnom);
teller = 0;
xud = zeros(21,9);
% Using small pertubations (+- 0.001) in three dimensions
for i=1:length(unom) %u1
    for j =1:length(unom) %u2
        %for k = 1:length(unom) u3 already constrained
            %if i==2 || j==2 %|| k==2
            ceq= ['ceq=[(Ri_DW-rout_DW)/Ri_DW;(rout-Ri)/Ri;ExplEq; x(1)-' ...
                ,num2str(unom(1)*udiff(i))...
                ';x(2)-', num2str(unom(2)*udiff(j)),'];'];
            filehandle(ceq); % Rewrite the constraint file
            %if teller == 9
            %    x0 = squeeze(xud(:,8));
            %end
            x0(1) = x0(1)*udiff(i);x0(2)=x0(2)*udiff(j);%x0(4)=x0(4)*udiff(k);
            teller = teller +1 ;
            %[xud(i,j,k), costu(i,j,k)] = optimizeru(Vo_in,qin,x0);
            %[xud(:,teller), costu(i,j,k)] = optimizeru(Vo_in,qin,x0) <-this one;
            [xud(:,teller), costu(i,j)] = optimizeru(Vo_in,qin,x0);
            %else
            %    teller = teller + 1;
            %end
        %end
    end
    ceq = [''];
    filehandle(ceq); % Reset the constraint file
    x0 = squeeze(xnom);
end
% Calcualte the finite differences using central step method
Ju1u1 = (costu(3,2)-2*costu(2,2)+costu(1,2))/(0.001^2);
Ju1u2 = (costu(3,3)-costu(3,1)-costu(1,3)+costu(1,1))/(4*0.001*0.001);
Ju2u2 = (costu(2,3)-2*costu(2,2)+costu(2,1))/(0.001^2);
Ju2u1 = Ju1u2;
% Build Hessian matrix for the cost function
Juu = [Ju1u1 Ju1u2;Ju2u1 Ju2u2];
%% Calculate Gain Matrix (Gy) = Jacobian of measurements/inputs

deltau = 0.001;
% Calculating differentials using finite differences
Gy1 = (xud(6:21,7)-xud(6:21,1))/(2*deltau);  %deltay/deltau1
Gy2 = (xud(6:21,6)-xud(6:21,4))/(2*deltau); %deltay/deltau2
Gy = [Gy1 Gy2];
% Remove measurement correlated with u3 => x19 = y14
Gy(yc,:) = [];
%% Scaling Matrices, Y, M and H
noisevec1 = zeros(ny,1);%zeros(ny,1);
noisevec2 = zeros(ny,1);%zeros(ny,1);
% Insert measurement noise 
% High accuracy: set w_1
for i=1:ny
    if mod(i,2) == 1
        noisevec1(i) = 0.01/3600; % Odd for q  (UNIT: /3600 or NOT?)
    else
        noisevec1(i) = 0.001; % even for oilcut
    end
end
% % Low accuracy: set w_2
for i=1:ny
    if mod(i,2) == 1
        noisevec2(i) = 0.4/3600 ;%0.1/3600; % Odd for q (UNIT: /3600 or NOT?)
    else 
        noisevec2(i) = 0.02;%0.01; % Even for oil-cut
    end
end
% Keep u3 => y14
Wn14(1) = noisevec1(yc);
Wn14(2) = noisevec2(yc);
% Remove u3 => y14
noisevec2(yc) = [];
noisevec1(yc) = [];

% Insert disturbance noise here!!
Wd = diag([5/3600 0.2]); %[q alfa]
Wn1 = diag(noisevec1);
Wn2 = diag(noisevec2);
% Extend length of F and Gy
Y1 = [F*Wd Wn1];
Y2 = [F*Wd Wn2];

% H = Gy'*inv(Y*Y');
% M = ((Juu)^(1/2))*inv(H*Gy)*H*Y;
% Lwc = (0.5*max(svd(M)))^2;
% Lavg = 0.5*norm((Juu^(1/2)/(H*Gy))*H*Y,'fro')^2;

% Test for convexity (positive semi definite)
posdef = find(eig(Juu) < 0);
if isempty(posdef) == false
    disp('Hessian is not positive definite')
else
    disp('Hessian is positive definite')
end


%% Mesurement selection
Ydel1=Y1;
Ydel2=Y2;
for i=1:nu-1-nc
    Ydel1=blkdiag(Ydel1,Y1);
    Ydel2=blkdiag(Ydel2,Y2);
    size(Ydel1);
    size(Ydel2);
end
Fdel1=Ydel1*Ydel1';
Fdel2=Ydel2*Ydel2';
Fdel = blkdiag(Fdel1,Fdel2);

Juu12 = Juu^(1/2);

Gydel=[];
for i=1:nu-nc
    Gydel=blkdiag(Gydel,Gy);
end
Gydel';
Gydel = [Gydel;Gydel];
Gyres = [Gy;Gy]; % For loss calculation only
Yres = [Y1;Y2]; % For loss calculation only
jdel=[];
for i=1:nu-nc
    jdel=[jdel ; Juu12(:,i)];
end
Y = [Y1;Y2]; % For loss Calculation only
Gy1 = [Gy;Gy]; % For loss calculation only
% Create GUROBI model
%% Find the optimal number of measurements
M = 1e3; %Big-M
% Prices of measurements
Loss = zeros(1,ny-nc);
mprices = zeros(1,ny);
mprices2= zeros(1,ny);
for i = 1:ny
    if mod(i,2) == 1
        mprices(i) = 0.001; % Flow w1
        mprices2(i) = 0.0005; %Flow w2
    else
        mprices(i) = 0.002; %Oil fraction w1
        mprices2(i) = 0.001;% Oil fraction, w2
    end
end
mprices(yc) = [];%removed constrained measurement
mprices2(yc) = []; 
% Prices for the constraint
cprices = [mprices(2) mprices2(2)]; % w1 w2

%Define empty matrices
Hres=zeros(nuc,2*nyc,length(nuc:nyc));
Meas=zeros(2,nyc,length(nuc:nyc));
cmeas=zeros(1,2,length(nu-nc:ny));
Hcons = zeros(2,2,length(nuc:nyc));
Hadj = zeros(nuc,2*nyc,length(nuc:nyc));
price = zeros(length(nuc:nyc),1); % price of measurements
loss = zeros(length(nuc:nyc),1); % Unconstrained loss
closs = zeros(length(nuc:nyc),1); % Constrained loss
cost = zeros(length(nuc:nyc),1); % price+loss+closs
ltot =zeros(length(nuc:nyc),1); % Total loss 

subM = zeros(nyc*nuc*2,nyc*2); 
% Selection criteria between each measurement set.
for i=1:nyc
        subM(i,i+nyc) = 1;
        subM(i+nyc,i+nyc)=1;
        subM(i+2*nyc,i) = 1;
        subM(i+3*nyc,i) = 1;
end
consumat = eye(nyc*nuc); %diag(helpvec)
sigma1Mconstr = -M*([repmat(eye(nyc),nu-1,1);zeros(nyc*nuc,nyc)]);
sigma2Mconstr = -M*([zeros(nyc*nuc,nyc);repmat(eye(nyc),nu-1,1)]);
tic
% MIQP Model for Gurobi starts here
for nm = nuc:nyc 
    Q=blkdiag(Fdel,zeros(nyc,nyc),zeros(nyc,nyc),0,zeros(4,4)); 
        %H            sigma_w1             sigma_w2      nm  sigma_c H_c
  
    A= [Gydel'            zeros(nuc*nuc,nyc)    zeros(nuc*nuc,nyc)      zeros(nuc*nuc,1) zeros(4,4) ;
        zeros(1,nuc*nyc*2)  ones(1,nyc)           ones(1,nyc)       -1              zeros(1,4);
       -blkdiag(eye(nuc*nyc),eye(nuc*nyc))     sigma1Mconstr      sigma2Mconstr  zeros(nuc*nyc*2,1) zeros(nuc*nyc*2,4) ;
        blkdiag(eye(nuc*nyc),eye(nuc*nyc))     sigma1Mconstr      sigma2Mconstr  zeros(nuc*nyc*2,1) zeros(nuc*nyc*2,4);
        zeros(1,nuc*nyc*2)  zeros(1,nyc)   zeros(1,nyc)               1   zeros(1,4) ;
        eye(nuc*nyc*2)      M*subM          zeros(nyc*nuc*2,1) zeros(nuc*nyc*2,4);
       -eye(nuc*nyc*2)      M*subM          zeros(nyc*nuc*2,1) zeros(nuc*nyc*2,4);
       zeros(1,nuc*nyc*2+2*nyc+1) 1 1 0 0;
       zeros(1,nuc*nyc*2+2*nyc+1) 1 0 0 1;
       zeros(1,nuc*nyc*2+2*nyc+1) 0 1 1 0;
        zeros(1,nuc*nyc*2)   mprices         mprices2          0 cprices(1) cprices(2) 0 0;
       ];

    c = [zeros(1,nuc*nyc*2) mprices mprices2       0     cprices(1) cprices(2) 0 0];
    c(end-1) = lambda*Wn14(1); % Back-off loss
    c(end) = lambda*Wn14(2); % Back-off loss
    lb=[-inf(nuc*nyc*2,1);  zeros(nyc,1); zeros(nyc,1)  ;0;0;0  ; -inf ;-inf];
    ub=[inf(nuc*nyc*2,1);   ones(nyc,1) ; ones(nyc,1)  ;nyc;1;1 ;inf;inf];

    b= [jdel; 
        0
        zeros(2*nuc*nyc,1);
        zeros(2*nuc*nyc,1)
        nm
        M*ones(2*nuc*nyc,1)
        M*ones(2*nuc*nyc,1)
        1
        1
        1
        M;%0.0048 % Insert budget constraint here!
      ];

    %try
        clear model;
        
        model.varnames = namescript(nuc,ny,yc);
        for n = 1:nyc
             model.sos(n).type =1;
             model.sos(n).index=[(4*nyc+n) (5*nyc+n)];
             model.sos(n).weight=[1 1];
         end

%         
        model.Q = 0.5*sparse(Q);
        model.A = sparse(A);
        model.obj = c;
        model.rhs = b;
        model.lb = lb;
        model.ub = ub;
        model.sense = [repmat('=',nuc*nuc+1,1);repmat('<',2*nuc*nyc,1);...
            repmat('<',2*nuc*nyc,1);'=';repmat('<',2*nuc*nyc,1);...
            repmat('<',2*nuc*nyc,1);'=';'=';'=';'<'];
        model.modelsense='min';
        model.vtype = [repmat('C',2*nuc*nyc,1);repmat('B',2*nyc,1);'I';...
                        repmat('B',2,1);repmat('B',2,1)];
        gurobi_write(model, 'qp2.lp');
        % Parameters for better solving of the MIQP
        params.Presolve = 2;
        params.MIPFocus = 3;
        params.NumericFocus = 3;
        params.FeasibilityTol=1e-9;
        params.OptimalityTol=1e-9;
        params.IntFeasTol = 1e-9;
        results = gurobi(model, params) 
        Hres(:,:,nm-nuc+1) = [results.x(1:nyc)'   results.x(2*nyc+1:3*nyc)';...
                          results.x(nyc+1:2*nyc)' results.x(3*nyc+1:4*nyc)';...
                          ];
        H = Hres(:,:,nm-nuc+1);
        %Selection matrix
        Meas(:,:,nm-nuc+1) = [results.x(4*nyc+1:5*nyc)';...
                              results.x(5*nyc+1:6*nyc)'];
                              
        cmeas(:,:,nm-(nuc)+1) = [results.x(end-3:end-2)'];
        Hcons(:,:,nm-nuc+1)= [results.x(end-3:end-2)';results.x(end-1:end)'];
        %cost(nm-nuc+1)= results.x'*Q*results.x+model.obj*results.x;
        loss1= 0.5*norm(Juu12/(H*Gyres)*H*Yres,'fro')^2; % Unconstrained loss
        loss(nm-(nu-nc)+1)= (results.x'*Q*results.x)/2;%+model.obj*results.x;
        % Test for error in the loss calculation: Optimizer vs. 
        % Exact local method
        if abs(loss(nm-(nu-nc)+1)-loss1) > 1e-3 && nm~=2
            disp('Error in unconstrained loss calculation')
            break
        end
        
        
        closs(nm-(nuc)+1) = c(end-1:end)*results.x(end-1:end);
        price(nm-(nuc)+1) = c(1:end-2)*results.x(1:end-2);
        ltot(nm-(nuc)+1) = loss(nm-(nuc)+1) + closs(nm-(nuc)+1);
        cost(nm-(nuc)+1) = loss(nm-(nuc)+1)+closs(nm-(nuc)+1)...
                        +price(nm-(nuc)+1);
end
toc
%%
 losslimit = loss(end)*1.2; % Add a maximum of 10% deviation     
for m = 1:length(loss)
    if loss(m) < losslimit
        fprintf('============== SUMMARY 20%% method =============\n')
        fprintf('Ideal number of measurements is %f.\n',m+nuc-1)
        fprintf('Corresponding Loss is %f. \n',loss(m))
        fprintf('Corresponding Cost is %f. \n',cost(m))
        break
    end
end
%% Remove zero entries

loss = loss(loss~=0)
price= price(price~=0)
cost = cost(cost~=0)
% Trying out the minimum cost method
[mincost, imincost] = min(cost);
        fprintf('======= SUMMARY minimum cost method =======\n')
        fprintf('Ideal number of measurements is %f.\n',imincost+nuc-1)
        fprintf('Corresponding Loss is %f. \n',loss(imincost))
        fprintf('Corresponding Price is %f. \n',price(imincost))
        fprintf('Corresponding Cost is %f. \n',cost(imincost))
clossbud = closs(imincost);
pricebud = price(imincost);
lossbud = loss(imincost);
%% Plot the graph unconstrained loss
figname = 'subseaactivecostbud';
hFig = figure('Name',figname);
set(hFig,'NumberTitle','off');
plot(nuc:7,cost(1:6),'Linewidth',2)
ax = gca;
set(ax,'XTick',[2,3,4,5,6,7]);
set(ax,'TickLabelInterpreter', 'latex');
xlabel('Number of Measurements','Interpreter','Latex');
%ylabel('Loss $\frac{1}{2}||M||_ 2^2$','Interpreter','Latex');
ylabel('Total Cost','interpreter','latex');
%  rectangle('Position',[3 0.005 3 0.005],'LineStyle',':');
%  line([3 6.8],[0.01 .023],'color','black','LineStyle',':');
%  line([6 15],[0.01 .023],'color','black','LineStyle',':');
% 
% 
% axes('position',[.4 .5 .45 .35])
% box on
% plot(3:6,cost(2:5))
% axis tight;
% 
% ax = gca;
% ax.YAxis.TickLabelFormat = '%.1f';
% ax.XTick=  3:1:6;
% %ax.YTick= 2e-4:4e-4:1e-3;
% set(ax,'TickLabelInterpreter', 'latex');
% %legendtext{i} = ['Price = ',num2str(price(i))];
% % set(hFig,'Interpreter','latex');
% % h = legend(legendtext,'Location','Best');
% % set(h,'Interpreter','latex');


%%
matlab2tikz([figname,'.tikz']);
%% Create bar plot 
costbar = [loss(3-1:7-1),price(3-1:7-1),closs(3-1:7-1)];
figname = 'costbreakup2';
hFig = figure('Name',figname);
set(hFig,'NumberTitle','off');
bar(costbar,'stacked')
legend('Unconstrained loss','Prices of measurements','Constrained back-off','location','east');
ax = gca;
ax.XTickLabel = [3 4 5 6 7];
set(ax,'TickLabelInterpreter', 'latex');
xlabel('Number of Measurements','Interpreter','Latex');
%ylabel('Loss $\frac{1}{2}||M||_ 2^2$','Interpreter','Latex');
ylabel('Cost of each component [$\$/s$]','interpreter','latex');

%% Create bar plot for budget
%cmap = colormap(parula(3));
%cmap = cmap(1:2,:);
lossbar = [lossnobud;lossbud];
pricebar = [pricenobud;pricebud];
clossbar = [clossnobud;clossbud];
costbar = [lossbar,pricebar,clossbar];
figname = 'activebudbar';
hFig = figure('Name',figname);
set(hFig,'NumberTitle','off');
%colormap(cmap)
bar(costbar,'stacked')
legend('Unconstrained loss','Prices of measurements','Constrained back-off','location','east');
ax = gca;
ax.XTickLabel = {'Without budget constraint','With budget constraint'};
set(ax,'TickLabelInterpreter', 'latex');
xlabel('Optimal subset','Interpreter','Latex');
%ylabel('Loss $\frac{1}{2}||M||_ 2^2$','Interpreter','Latex');
ylabel('Cost of each component [\frac{\$}{s}]','interpreter','latex');

%% Write the chosen measurements to file
names = namewrite(nuc,ny,yc);
%filewriter(Meas,loss,cost,names,qin,Vo_in,nm,nuc,nyc)
filename = 'selectedactivebud.txt';
%folder = ['../../../../Apps/ShareLaTeX/NTNU Masters Thesis/docs/'];
%filefolder = [folder,filename];
 fileID = fopen(filename,'w');
 fprintf(fileID, '\\begin{tabular}{l l c c} \n');
 fprintf(fileID, '\\toprule \n');
 fprintf(fileID, 'No. y & Selected Measurements & $L^{uncons}$& Price \\\\ \n');
 fprintf(fileID, '\\midrule \n');
for nm=3:7
        measidx = find(Meas(:,:,nm-1)');
        measidx = measidx + (nyc*nuc*2);
        measidx2 = find(cmeas(:,:,nm-1));
        measidx2 = measidx2 + (nyc*nuc*2+nyc*2+1);
        measidx3 = [measidx; measidx2]; % <.. this
        fprintf(fileID, ' %d(+1) & \\parbox[t]{5cm}{ %s } & %2.2g & %2.3g \\\\ \\hline \n',...
            nm, strjoin(names(measidx3),',\\\\'),loss(nm-1),price(nm-1));
 
end
 fprintf(fileID,'\\bottomrule \n');
 fprintf(fileID,'\\end{tabular} \n');
 fclose(fileID)
 
 %%
 finalh = Hres(:,:,imincost);
 finalh(:,~any(finalh,1)) = [];
 filename2 = 'selectionmatrix2.txt.';
 %folder = ['../../../../Apps/ShareLaTeX/NTNU Masters Thesis/docs/'];
filefolder2 = [filename2];
 fileID = fopen(filename2,'w');
 fprintf(fileID,'%% OBS: CRATED MANUALLY, Check against selection table \n');
 fprintf(fileID, '\\begin{align} \n');
% fprintf(fileID, '& \\quad\\quad q_bw_1 \\quad\\quad\\quad q_{LPO,DW}w_1 \\quad q_{HPO,DW}w_1 \\quad\\quad q_{in,DO}w_1 \\quad q_{LPO,DO}w_1 \\nonumber \\\\ \n');
 fprintf(fileID, 'H &= \\begin{bmatrix} \n');
 fprintf(fileID, '%3.2f & %3.2f & %3.2f & %3.2f  \\\\ \n',finalh(1,1),finalh(1,2),finalh(1,3),finalh(1,4));
 fprintf(fileID, '%3.2f & %3.2f & %3.2f & %3.2f  \\\\ \n',finalh(2,1),finalh(2,2),finalh(2,3),finalh(2,4));
 fprintf(fileID, ' \\end{bmatrix}\\label{eq:subseaHbud} \n');
 fprintf(fileID,'\\end{align} \n');
 fclose(fileID)

 
 