% Script for selfoptimizing control
% Calculates measurements through exact local method
% For areas with three DoF
clear all
clc
qin  = 20/3600; % Define a nominal point, inflow 
Vo_in = 0.4;    % Define a nominal point, oil fraction
% Nominal point
%[xnom, cost2] = optimizer(Vo_in,qin);
load('xnomadj2.mat');% Using results from simulations as start points
%lambda = load('lambda1.mat');% Using lambda from simulation 
xnom = squeeze(x(9,5,:));
lambda = 2.894e-4;
%lambda = lambda.lambda1;
nu = 3; ny =16; nd = 2; nc=0;% Number of inputs, measurements, disturbances
yc = 14; % Which y is linked to constrained u3?
nyc = ny-nc; %Total available measurements
nuc = nu-nc; %Total available inputs
%% Add 1% Disturbance to calculate F
di =1.01;
d1 = qin*di;
d2 = Vo_in*di;
deltad1 = d1-qin;
deltad2 = d2-Vo_in;
for i=1:2
    if i == 1
        [xd1, costd1] = optimizer(Vo_in,d1,xnom);
    else 
        [xd2, costd2]= optimizer(d2,qin,xnom);
    end
end
xd = squeeze([xd1 xd2])';
d = [deltad1 deltad2];
%% Calculates sensitivity matrix
F = zeros(ny,nd);
for j = 6:length(xnom)
    for i = 1:length(d)
        F(j-5,i) = (xd(j,i)-xnom(j))/d(i);
    end
end

%% Calculate Juu (Hessian)

costu = zeros(nu,nu);
%xud = zeros(nu,nu,nu);
udiff = [0.999 1 1.001];
unom = [xnom(1) xnom(2) xnom(4)];
x0 = squeeze(xnom);
teller = 0;
xud = zeros(21,9);
% Using small pertubations (+- 0.001) in three dimensions
for i=1:length(unom) %u1
    for j =1:length(unom) %u2
        for k = 1:length(unom) %u3
            if i==2 || j==2 || k==2
            ceq= ['ceq=[(Ri_DW-rout_DW)/Ri_DW;(rout-Ri)/Ri;ExplEq; x(1)-' ...
                num2str(unom(1)*udiff(i))...
                ';x(2)-' num2str(unom(2)*udiff(j))...
                ';x(4)-' num2str(unom(3)*udiff(k)) '];'];
            filehandle(ceq);
            x0(1) = x0(1)*udiff(i);x0(2)=x0(2)*udiff(j);x0(4)=x0(4)*udiff(k);
            teller = teller +1 ;
            %[xud(i,j,k), costu(i,j,k)] = optimizeru(Vo_in,qin,x0);
            [xud(:,teller), costu(i,j,k)] = optimizeru(Vo_in,qin,x0);
            else
                teller = teller + 1;
            end
        end
    end
    ceq = [''];
    filehandle(ceq);
    x0 = squeeze(xnom);
end
%Calcualte the finite differences using central step method
Ju1u1 = (costu(3,2,2)-2*costu(2,2,2)+costu(1,2,2))/(0.001^2);
Ju1u2 = (costu(3,3,2)-costu(3,1,2)-costu(1,3,2)+costu(1,1,2))/(4*0.001*0.001);
Ju2u2 = (costu(2,3,2)-2*costu(2,2,2)+costu(2,1,2))/(0.001^2);
Ju1u3 = (costu(3,2,3)-costu(3,2,1)-costu(1,2,3)+costu(1,2,1))/(4*0.001*0.001);
Ju2u3 = (costu(2,3,3)-costu(2,3,1)-costu(2,1,3)+costu(2,1,1))/(4*0.001*0.001);
Ju3u3 = (costu(2,2,3)-2*costu(2,2,2)+costu(2,2,1))/(0.001^2);
%Ju1u1 = (costu(3,2)-2*costu(2,2)+costu(1,2))/(0.001^2);
%Ju1u2 = (costu(3,3)-costu(3,1)-costu(1,3)+costu(1,1))/(4*0.001*0.001);
%Ju2u2 = (costu(2,3)-2*costu(2,2)+costu(2,1))/(0.001^2);
Ju2u1 = Ju1u2;
Ju3u1 = Ju1u3;
Ju3u2 = Ju2u3;
% Build Hessian matrix for the cost function
Juu = [Ju1u1 Ju1u2 Ju1u3;Ju2u1 Ju2u2 Ju2u3; Ju3u1 Ju2u3 Ju3u3];
%Juu = [Ju1u1 Ju1u2;Ju2u1 Ju2u2];
%% Calculate Gain Matrix (Gy) = Jacobian of measurements/inputs

% clc
% x0 = squeeze(xnom);
% unom = [xnom(1) xnom(2) xnom(4)]; % Fs_g Fs_dw Fs_do
% ui = 1.01; % Add 1% to input
% for i=1:2
%     switch i
%         case 1
%        ceq = ['ceq=[(Ri_DW-rout_DW)/Ri_DW;(rout-Ri)/Ri;x(19)-0.03;ExplEq;x(1)-' num2str(unom(1)) ';x(2)-' num2str(unom(2)*ui) '];'];
%        filehandle(ceq);
%         x01 = x0;
%         x01(2) = x01(2)*ui;
%         [xu4, cost4] = optimizeru(Vo_in,qin,x01);
%         case 2 
%         ceq1= ['ceq=[(Ri_DW-rout_DW)/Ri_DW;(rout-Ri)/Ri;ExplEq;x(19)-0.03;x(1)-' num2str(unom(1)*ui) ';x(2)-' num2str(unom(2)) '];']; 
%         filehandle(ceq1);
%         x02 = x0;
%         x02(1) = x02(1)*ui;
%         [xu1, cost1] = optimizeru(Vo_in,qin,x02);
%         
%     end
% %     ceqreset = '';
% %     filehandle(ceqreset);
% end
%xu = squeeze([xu4 xu1]);
deltau = 0.001;
% Calculating differentials using finite differences
% Gy1 = (xud(6:21,7)-xud(6:21,1))/(2*deltau);  %deltay/deltau1
% Gy2 = (xud(6:21,6)-xud(6:21,4))/(2*deltau); %deltay/deltau2
%Gy3 = (xud(6:21,15)-xud(6:21,13))/(2*deltau); %deltay/deltau3
Gy1 = (xud(6:21,26)-xud(6:21,5))/(2*deltau);  %deltay/deltau1
Gy2 = (xud(6:21,17)-xud(6:21,11))/(2*deltau); %deltay/deltau2
Gy3 = (xud(6:21,15)-xud(6:21,13))/(2*deltau); %deltay/deltau3
%Gy1 = deltay1/deltau(1);
%Gy2 = deltay2/deltau(2);
%Gy = [Gy1 Gy2 Gy3];
Gy = [Gy1 Gy2 Gy3];
% Remove measurement correlated with u3 => x19 = y14
%% Scaling Matrices, Y, M and H
noisevec1 = zeros(ny,1);%zeros(ny,1);
noisevec2 = zeros(ny,1);%zeros(ny,1);
% Insert measurement noise 
% High accuracy
for i=1:ny
    if mod(i,2) == 1
        noisevec1(i) = 0.01/3600; % Odd for q  (UNIT: /3600 or NOT?)
    else
        noisevec1(i) = 0.001; % even for oilcut
    end
end
% % Low accuracy
for i=1:ny
    if mod(i,2) == 1
        noisevec2(i) = 0.4/3600 ;%0.1/3600; % Odd for q (UNIT: /3600 or NOT?)
    else 
        noisevec2(i) = 0.02;%0.01; % Even for oil-cut
    end
end

% Insert disturbance noise here!!
Wd = diag([5/3600 0.2]); %[q alfa]
Wn1 = diag(noisevec1);
Wn2 = diag(noisevec2);
% Extend length of F and Gy

Y1 = [F*Wd Wn1];
Y2 = [F*Wd Wn2];

% H = Gy'*inv(Y*Y');
% M = ((Juu)^(1/2))*inv(H*Gy)*H*Y;
% Lwc = (0.5*max(svd(M)))^2;
% Lavg = 0.5*norm((Juu^(1/2)/(H*Gy))*H*Y,'fro')^2;
% Test for convexity (positive semi definite)
posdef = find(eig(Juu) < 0);
if isempty(posdef) == false
    disp('Hessian is not positive definite')
else
    disp('Hessian is positive definite')
end


%% Mesurement selection
Ydel1=Y1;
Ydel2=Y2;
for i=1:nu-1
    Ydel1=blkdiag(Ydel1,Y1);
    Ydel2=blkdiag(Ydel2,Y2);
    size(Ydel1);
    size(Ydel2);
end
Fdel1=Ydel1*Ydel1';
Fdel2=Ydel2*Ydel2';
Fdel = blkdiag(Fdel1,Fdel2);


%hdelta = [H(1,:) H(2,:) H(3,:)]; % Make Matrix H a row vector
Juu12 = Juu^(1/2);
%jdelta = [Juu12(1,:) Juu12(2,:) Juu12(3,:)];


Gydel=[];
for i=1:nu
    Gydel=blkdiag(Gydel,Gy);
end
Gydel';
Gydel = [Gydel;Gydel];
Gyres = [Gy;Gy]; % For loss calculation only
Yres = [Y1;Y2]; % For loss calculation only
jdel=[];
for i=1:nu
    jdel=[jdel ; Juu12(:,i)];
end
Y = [Y1;Y2]; % For loss Calculation only
Gy1 = [Gy;Gy]; % For loss calculation only
% Create GUROBI model
%% Find the optimal number of measurements
M = 1e3;
% Prices of measurements
Loss = zeros(1,ny);
mprices = zeros(1,ny);
mprices2= zeros(1,ny);
for i = 1:ny
    if mod(i,2) == 1
        mprices(i) = 0.001; % Flow w1
        mprices2(i) = 0.0005; %Flow w2
    else
        mprices(i) = 0.002; %Oil fraction w1
        mprices2(i) = 0.001;% Oil fraction, w2
    end
end
%mprices(yc) = [];%removed constrained measurement
%mprices2(yc) = []; 
%mprices = [zeros(1,ny) 1e5*ones(1,ny)];
%cprices = [mprices(2) mprices2(2)]; % w1 w2
% Measurements required

%Define empty matrices
Hres=zeros(nuc,2*nyc,length(nuc:nyc));
Meas=zeros(2,nyc,length(nuc:nyc));
%cmeas=zeros(1,2,length(nu-nc:ny));
%Hcons = zeros(2,2,length(nuc:nyc));
Hadj = zeros(nuc,2*nyc,length(nuc:nyc));
price = zeros(length(nuc:nyc),1); % price of measurements
loss = zeros(length(nuc:nyc),1); % Unconstrained loss
%closs = zeros(length(nuc:nyc),1); % Constrained loss
cost = zeros(length(nuc:nyc),1); % price+loss+closs
%ltot =zeros(length(nuc:nyc),1); % Total loss 

subM = zeros(nyc*nuc*2,nyc*2); 
for i=1:nyc
        subM(i,i+nyc) = 1;
        subM(i+nyc,i+nyc)=1;
        subM(i+2*nyc,i) = 1;
        subM(i+3*nyc,i) = 1;
end
%helpvec = ones(ny*nu,1);
%helpvec(nyc*(consu-1)+1:nyc*(consu-1)+nyc) = 0;
consumat = eye(nyc*nuc); %diag(helpvec)
%sigma1Mconstr = -M*([consumat*repmat(eye(ny),nu,1);zeros(2*ny,ny)]);
%sigma2Mconstr = -M*([zeros(2*ny,ny);consumat*repmat(eye(ny),nu,1)]);
sigma1Mconstr = -M*([repmat(eye(nyc),nu,1);zeros(nyc*nuc,nyc)]); %nu obs
sigma2Mconstr = -M*([zeros(nyc*nuc,nyc);repmat(eye(nyc),nu,1)]); %nu obs
%for nm = nuc:nyc
tic

for nm = nuc:nyc
 
    Q=blkdiag(Fdel,zeros(nyc,nyc),zeros(nyc,nyc),0); %Last two is for u1
        %H            sigma_w1             sigma_w2      nm  sigma_c H_c
 
    A= [Gydel'            zeros(nuc*nuc,nyc)    zeros(nuc*nuc,nyc)      zeros(nuc*nuc,1)  ;
        zeros(1,nuc*nyc*2)  ones(1,nyc)           ones(1,nyc)       -1            ;
       -blkdiag(eye(nuc*nyc),eye(nuc*nyc))     sigma1Mconstr      sigma2Mconstr  zeros(nuc*nyc*2,1) ;
        blkdiag(eye(nuc*nyc),eye(nuc*nyc))     sigma1Mconstr      sigma2Mconstr  zeros(nuc*nyc*2,1) ;
        zeros(1,nuc*nyc*2)  zeros(1,nyc)   zeros(1,nyc)               1   ;
        eye(nuc*nyc*2)      M*subM          zeros(nyc*nuc*2,1) ;
       -eye(nuc*nyc*2)      M*subM          zeros(nyc*nuc*2,1);
%        zeros(1,nuc*nyc*2+2*nyc+1) 1 1 0 0;
%        zeros(1,nuc*nyc*2+2*nyc+1) 1 0 0 1;
%        zeros(1,nuc*nyc*2+2*nyc+1) 0 1 1 0;
        zeros(1,nuc*nyc*2)   mprices         mprices2          0;
    %   zeros(1,nuc*nyc*2)   mprices         mprices2          0 cprices 0 0;
    %   zeros(1,nuc*ny*2+2*ny+1) 
    %   [1 zeros(1,ny*nuc-1) 1 zeros(1,ny*nuc-1)]  [-1 0 0 0]     [-1 0 0 0] 0 %u1 restricted
    %   [0 0 1 0 0 0 1 0]  [-1 0]     [-1 0] 0;
    %    [0 1 0 0 0 1 0 0]  [0 -1]     [0 -1] 0; % u2 restricted
    %    [0 0 0 1 0 0 0 1]  [0 -1]     [0 -1] 0;
       ];

    c = [zeros(1,nuc*nyc*2) mprices mprices2       0     ];
    %c(end-1) = lambda*Wn14(1);
    %c(end) = lambda*Wn14(2);
    %c(ny*nuc*(consu-1)+1:ny*nuc*(consu-1)+ny) = lambda(consu)*Wn1vec;
    %c(ny*nuc*(consu-1)+ny*nuc+1:ny*nuc*(consu-1)+ny*nuc+ny) = lambda(consu)*Wn2vec;
   % c = [ones(1,nu*ny*2)*(measprice/2) zeros(1,2*nyc)                0              ];
    lb=[-inf(nuc*nyc*2,1);  zeros(nyc,1); zeros(nyc,1)  ;0];
    ub=[inf(nuc*nyc*2,1);   ones(nyc,1) ; ones(nyc,1)  ;nyc];

    b= [jdel; 
        0
        zeros(2*nuc*nyc,1);
        zeros(2*nuc*nyc,1)
        nm
        M*ones(2*nuc*nyc,1)
        M*ones(2*nuc*nyc,1)
       % 1
       % 1
       % 1
        M;%0.0028
        %  0
      %  0
      ];

    %try
        clear model;
%         
%         model.varnames = namescript2(nuc,ny);
%         for n = 1:nyc
%              model.sos(n).type =1;
%              model.sos(n).index=[(4*nyc+n) (5*nyc+n)];
%              model.sos(n).weight=[1 1];
% %              model.sos(n+ny).type =1;
% %              model.sos(n+ny).index=[(n+ny*nu) (n+ny*nu)+2];
% %              model.sos(n+ny).weight=[1 1];
%          end

%         
        model.Q = 0.5*sparse(Q);
        model.A = sparse(A);
        model.obj = c;
        model.rhs = b;
        model.lb = lb;
        model.ub = ub;
        model.sense = [repmat('=',nuc*nuc+1,1);repmat('<',2*nuc*nyc,1);...
            repmat('<',2*nuc*nyc,1);'=';repmat('<',2*nuc*nyc,1);...
            repmat('<',2*nuc*nyc,1);'<'];
       %model.sense = [repmat('=',nu*nu+1,1);repmat('<',2*nu*nyc,1);repmat('<',2*nu*ny,1);'=']
        model.modelsense='min';
        model.vtype = [repmat('C',2*nuc*nyc,1);repmat('B',2*nyc,1);'I'];
      % model.vtype([(ny*(consu-1)+1):(ny*(consu-1)+ny)...
      %              (ny*(consu-1)+ny*nuc+1):(ny*nuc*(consu-1)+nuc*ny+ny)]) = 'B';
        gurobi_write(model, 'noconstraint.lp');
       params.Presolve = -1;
       params.MIPFocus = 3;
        params.NumericFocus = 3;
        params.FeasibilityTol=1e-9;
        params.OptimalityTol=1e-9;
        params.IntFeasTol = 1e-9;
        results = gurobi(model, params) 
        Hres(:,:,nm-nuc+1) = [results.x(1:nyc)'   results.x(nuc*nyc+1:nuc*nyc+nyc)' ;...
                          results.x(nyc+1:2*nyc)' results.x(nuc*nyc+nyc+1:nuc*nyc+2*nyc)';...
                          results.x(2*nyc+1:3*nyc)' results.x(nuc*nyc+2*nyc+1:nuc*nyc*2)';...
                          ];
        H = Hres(:,:,nm-nuc+1);
        %Selection matrix
        Meas(:,:,nm-nuc+1) = [results.x(nyc*nuc*2+1:nyc*nuc*2+nyc)';...
                              results.x(nyc*nuc*2+nyc+1:nyc*nuc*2+2*nyc)'];
                            
     %   cmeas(:,:,nm-(nuc)+1) = [results.x(end-3:end-2)'];
        %Hcons(:,:,nm-nuc+1)= [results.x(end-3:end-2)';results.x(end-1:end)'];
        %cost(nm-nuc+1)= results.x'*Q*results.x+model.obj*results.x;
        loss1= 0.5*norm(Juu12/(H*Gyres)*H*Yres,'fro')^2; % Unconstrained loss
        loss(nm-(nu-nc)+1)= (results.x'*Q*results.x)/2;%+model.obj*results.x;
        
        if abs(loss(nm-(nu-nc)+1)-loss1) > 1e-3 && nm~=2
            disp('Error in unconstrained loss calculation')
            break
        end
       % Loss(i) = 0.5*norm(Juu12/(H*Gy)*H*Y,'fro')^2;
        %fprintf('Loss, GUROBI MIQP:\t%f\n',0.5*norm(Juu12/(H*Gy)*H*Y,'fro')^2 )
        
        
    %    closs(nm-(nuc)+1) = c(end-1:end)*results.x(end-1:end);
        price(nm-(nuc)+1) = c(1:end-1)*results.x(1:end-1);
        %ltot(nm-(nuc)+1) = loss(nm-(nuc)+1) + closs(nm-(nuc)+1);
        cost(nm-(nuc)+1) = loss(nm-(nuc)+1)+...
                        +price(nm-(nuc)+1);
end
toc
%%
 losslimit = loss(end)*1.2; % Add a maximum of 10% deviation     
for m = 1:length(loss)
    if loss(m) < losslimit
        fprintf('============== SUMMARY 20%% method =============\n')
        fprintf('Ideal number of measurements is %f.\n',m+nuc-1)
        fprintf('Corresponding Loss is %f. \n',loss(m))
        fprintf('Corresponding Cost is %f. \n',cost(m))
        break
    end
end
%% Remove zero entries

loss = loss(loss~=0)
price= price(price~=0)
cost = cost(cost~=0)
% Trying out the minimum cost method
[mincost, imincost] = min(cost);
        fprintf('======= SUMMARY minimum cost method =======\n')
        fprintf('Ideal number of measurements is %f.\n',imincost+nuc-1)
        fprintf('Corresponding Loss is %f. \n',loss(imincost))
        fprintf('Corresponding Price is %f. \n',price(imincost))
        fprintf('Corresponding Cost is %f. \n',cost(imincost))
%clossbud = closs(imincost);
pricebud = price(imincost);
lossbud = loss(imincost);
%% Plot the graph unconstrained loss
figname = 'subseacost';
hFig = figure('Name',figname);
set(hFig,'NumberTitle','off');
%legendtext = {'Adjusted Gurobi solver parameters','Standard Gurobi solver parameters'};
plot(nuc:nyc,cost,'Linewidth',2)
ax = gca;
%h = legend(legendtext,'Location','southeast');
%set(h,'Interpreter','latex');
%set(ax,'XTick',[2,3,4,5,6,7]);
set(ax,'TickLabelInterpreter', 'latex');
xlabel('Number of Measurements','Interpreter','Latex');
%ylabel('Loss $\frac{1}{2}||M||_ 2^2$','Interpreter','Latex');
ylabel('Total Cost [$\$/s$]','interpreter','latex');
% rectangle('Position',[4 0 2 0.01],'LineStyle',':');
% line([4 6.8],[0.001 .006],'color','black','LineStyle',':');
% line([15 15],[0.001 .006],'color','black','LineStyle',':');


% axes('position',[.4 .5 .45 .35])
% box on
% plot(4:6,loss(3:5),'Linewidth',2)
% axis tight;
% 
% ax = gca;
% ax.YAxis.TickLabelFormat = '%.1f';
% set(ax,'TickLabelInterpreter', 'latex');


%%
matlab2tikz(['fig/',figname,'.tikz']);
%% Create bar plot 
cmap = colormap(parula(3));
cmap = cmap(1:2,:);
costbar = [loss(4-2:7-2),price(4-2:7-2)];
figname = 'costbreakup';

hFig = figure('Name',figname);
set(hFig,'NumberTitle','off');
colormap(cmap)
bar(costbar,'stacked')
legend('Unconstrained loss','Prices of measurements','location','northeast');
ax = gca;
ax.XTickLabel = [4 5 6 7];
set(ax,'TickLabelInterpreter', 'latex');
xlabel('Number of Measurements','Interpreter','Latex');
%ylabel('Loss $\frac{1}{2}||M||_ 2^2$','Interpreter','Latex');
ylabel('Cost [$\$/s$]','interpreter','latex');

%% Create bar plot for budget
cmap = colormap(parula(3));
cmap = cmap(1:2,:);
lossbar = [lossnobud;lossbud];
pricebar = [pricenobud;pricebud];
%clossbar = [clossnobud;clossbud];
costbar = [lossbar,pricebar];
figname = 'budget';
hFig = figure('Name',figname);
set(hFig,'NumberTitle','off');
colormap(cmap)
bar(costbar,'stacked')
legend('Unconstrained loss','Prices of measurements','location','northwest');
ax = gca;
ax.XTickLabel = {'Without budget constraint','With budget constraint'};
set(ax,'TickLabelInterpreter', 'latex');
xlabel('Optimal subset','Interpreter','Latex');
%ylabel('Loss $\frac{1}{2}||M||_ 2^2$','Interpreter','Latex');
ylabel('Cost [$\$/s$]','interpreter','latex');

%% Write the chosen measurements to file
names = namewrite2(nuc,ny);
%filewriter(Meas,loss,cost,names,qin,Vo_in,nm,nuc,nyc)
filename = 'selectedbud.txt';
%folder = ['../../../../Apps/ShareLaTeX/NTNU Masters Thesis/docs/'];
%filefolder = [folder,filename];
 fileID = fopen(['fig/',filename],'w');
 fprintf(fileID, '\\begin{tabular}{l l c c} \n');
 fprintf(fileID, '\\toprule \n');
 fprintf(fileID, 'No. y & Selected Measurements & $L^{uncons}$& Price \\\\ \n');
 fprintf(fileID, '\\midrule \n');
for nm=3:5
        measidx = find(Meas(:,:,nm-2)');
        measidx = measidx + (nyc*nuc*2);
        %measidx2 = find(cmeas(:,:,nm-1));
        %measidx2 = measidx2 + (nyc*nuc*2+nyc*2+1);
        %measidx3 = [measidx; measidx2]; % <.. this
        fprintf(fileID, ' %d & \\parbox[t]{5cm}{ %s } & %2.2g & %2.3g \\\\ \\hline \n',...
            nm, strjoin(names(measidx),',\\\\'),loss(nm-2),price(nm-2));
 
end
 fprintf(fileID,'\\bottomrule \n');
 fprintf(fileID,'\\end{tabular} \n');
 fclose(fileID)
 
 %%
 names = namewrite2(nuc,ny);
 finalh = Hres(:,:,imincost);
 finalh(:,abs(finalh(1,:))<1e-4) = [];
 measidx = find(Meas(:,:,imincost)');
 measidx = measidx + (nyc*nuc*2);
 filename2 = 'selectionmatrixbud.txt.';
 %folder = ['../../../../Apps/ShareLaTeX/NTNU Masters Thesis/docs/'];
filefolder2 = [filename2];
 fileID = fopen(['fig/',filename2],'w');
 fprintf(fileID,'%% OBS: CRATED MANUALLY, Check against selection table \n');
 fprintf(fileID, '\\begin{align} \n');
 fprintf(fileID, 'H &= \\begin{bmatrix} \n');
 fprintf(fileID,'  %s \\nonumber \\\\ \n',strjoin(names(measidx),'&'));
 fprintf(fileID, '%3.2f & %3.2f & %3.2f & %3.2f &    \\\\ \n',finalh(1,1),finalh(1,2),finalh(1,3),finalh(1,4));
 fprintf(fileID, '%3.2f & %3.2f & %3.2f & %3.2f & \\\\ \n',finalh(2,1),finalh(2,2),finalh(2,3),finalh(2,4));
 fprintf(fileID, '%3.2f & %3.2f & %3.2f & %3.2f &  \\\\ \n',finalh(3,1),finalh(3,2),finalh(3,3),finalh(3,4));
 fprintf(fileID, ' \\end{bmatrix}\\label{eq:subseaH} \n');
 fprintf(fileID,'\\end{align} \n');
 fclose(fileID)

 
 